Index: branches/HivePerformance/sources/HeuristicLab.Algorithms.GradientDescent/3.3/Lbfgs.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Algorithms.GradientDescent/3.3/Lbfgs.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Algorithms.GradientDescent/3.3/Lbfgs.cs	(revision 9444)
@@ -22,4 +22,6 @@
 
 using System;
+using System.Linq;
+using HeuristicLab.Analysis;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -51,10 +53,15 @@
     public string Filename { get; set; }
 
+    private const string AnalyzerParameterName = "Analyzer";
     private const string MaxIterationsParameterName = "MaxIterations";
     private const string ApproximateGradientsParameterName = "ApproximateGradients";
     private const string SeedParameterName = "Seed";
     private const string SetSeedRandomlyParameterName = "SetSeedRandomly";
+    private const string GradientCheckStepSizeParameterName = "GradientCheckStepSize";
 
     #region parameter properties
+    public IValueParameter<IMultiAnalyzer> AnalyzerParameter {
+      get { return (IValueParameter<IMultiAnalyzer>)Parameters[AnalyzerParameterName]; }
+    }
     public IValueParameter<IntValue> MaxIterationsParameter {
       get { return (IValueParameter<IntValue>)Parameters[MaxIterationsParameterName]; }
@@ -66,6 +73,13 @@
       get { return (IValueParameter<BoolValue>)Parameters[SetSeedRandomlyParameterName]; }
     }
+    public IValueParameter<DoubleValue> GradientStepSizeParameter {
+      get { return (IValueParameter<DoubleValue>)Parameters[GradientCheckStepSizeParameterName]; }
+    }
     #endregion
     #region properties
+    public IMultiAnalyzer Analyzer {
+      get { return AnalyzerParameter.Value; }
+      set { AnalyzerParameter.Value = value; }
+    }
     public int MaxIterations {
       set { MaxIterationsParameter.Value.Value = value; }
@@ -84,6 +98,4 @@
     [Storable]
     private LbfgsAnalyzer analyzer;
-    [Storable]
-    private LbfgsAnalyzer finalAnalyzer;
     [Storable]
     private Placeholder solutionCreator;
@@ -99,5 +111,4 @@
       updateResults = cloner.Clone(original.updateResults);
       analyzer = cloner.Clone(original.analyzer);
-      finalAnalyzer = cloner.Clone(original.finalAnalyzer);
       solutionCreator = cloner.Clone(original.solutionCreator);
       evaluator = cloner.Clone(original.evaluator);
@@ -106,12 +117,13 @@
     public LbfgsAlgorithm()
       : base() {
-      this.name = ItemName;
-      this.description = ItemDescription;
-
+      Parameters.Add(new ValueParameter<IMultiAnalyzer>(AnalyzerParameterName, "The analyzers that will be executed on the solution.", new MultiAnalyzer()));
       Parameters.Add(new ValueParameter<IntValue>(MaxIterationsParameterName, "The maximal number of iterations for.", new IntValue(20)));
       Parameters.Add(new ValueParameter<IntValue>(SeedParameterName, "The random seed used to initialize the new pseudo random number generator.", new IntValue(0)));
       Parameters.Add(new ValueParameter<BoolValue>(SetSeedRandomlyParameterName, "True if the random seed should be set to a random value, otherwise false.", new BoolValue(true)));
       Parameters.Add(new ValueParameter<BoolValue>(ApproximateGradientsParameterName, "Indicates that gradients should be approximated.", new BoolValue(true)));
-      Parameters[ApproximateGradientsParameterName].Hidden = true; // should not be changed
+      Parameters.Add(new OptionalValueParameter<DoubleValue>(GradientCheckStepSizeParameterName, "Step size for the gradient check (should be used for debugging the gradient calculation only)."));
+      // these parameter should not be changed usually
+      Parameters[ApproximateGradientsParameterName].Hidden = true;
+      Parameters[GradientCheckStepSizeParameterName].Hidden = true;
 
       var randomCreator = new RandomCreator();
@@ -122,6 +134,6 @@
       evaluator = new Placeholder();
       updateResults = new LbfgsUpdateResults();
-      analyzer = new LbfgsAnalyzer();
-      finalAnalyzer = new LbfgsAnalyzer();
+      var analyzerPlaceholder = new Placeholder();
+      var finalAnalyzerPlaceholder = new Placeholder();
 
       OperatorGraph.InitialOperator = randomCreator;
@@ -133,5 +145,5 @@
       randomCreator.Successor = solutionCreator;
 
-      solutionCreator.Name = "Solution Creator (placeholder)";
+      solutionCreator.Name = "(Solution Creator)";
       solutionCreator.Successor = initializer;
 
@@ -145,19 +157,23 @@
       branch.ConditionParameter.ActualName = makeStep.TerminationCriterionParameter.Name;
       branch.FalseBranch = evaluator;
-      branch.TrueBranch = finalAnalyzer;
-
-      evaluator.Name = "Evaluator (placeholder)";
+      branch.TrueBranch = finalAnalyzerPlaceholder;
+
+      evaluator.Name = "(Evaluator)";
       evaluator.Successor = updateResults;
 
       updateResults.StateParameter.ActualName = initializer.StateParameter.Name;
       updateResults.ApproximateGradientsParameter.ActualName = ApproximateGradientsParameterName;
-      updateResults.Successor = analyzer;
-
+      updateResults.Successor = analyzerPlaceholder;
+
+      analyzerPlaceholder.Name = "(Analyzer)";
+      analyzerPlaceholder.OperatorParameter.ActualName = AnalyzerParameterName;
+      analyzerPlaceholder.Successor = makeStep;
+
+      finalAnalyzerPlaceholder.Name = "(Analyzer)";
+      finalAnalyzerPlaceholder.OperatorParameter.ActualName = AnalyzerParameterName;
+      finalAnalyzerPlaceholder.Successor = null;
+
+      analyzer = new LbfgsAnalyzer();
       analyzer.StateParameter.ActualName = initializer.StateParameter.Name;
-      analyzer.Successor = makeStep;
-
-      finalAnalyzer.PointsTableParameter.ActualName = analyzer.PointsTableParameter.ActualName;
-      finalAnalyzer.QualityGradientsTableParameter.ActualName = analyzer.QualityGradientsTableParameter.ActualName;
-      finalAnalyzer.QualitiesTableParameter.ActualName = analyzer.QualitiesTableParameter.ActualName;
     }
 
@@ -185,4 +201,6 @@
         solutionCreator.OperatorParameter.ActualName = Problem.SolutionCreatorParameter.Name;
         evaluator.OperatorParameter.ActualName = Problem.EvaluatorParameter.Name;
+        UpdateAnalyzers();
+        ParameterizeOperators();
       }
     }
@@ -200,6 +218,11 @@
     }
 
+    protected override void Problem_OperatorsChanged(object sender, EventArgs e) {
+      base.Problem_OperatorsChanged(sender, e);
+      UpdateAnalyzers();
+    }
+
     private void RegisterSolutionCreatorEvents() {
-      var realVectorCreator = Problem.SolutionCreator as RealVectorCreator;
+      var realVectorCreator = Problem.SolutionCreator as IRealVectorCreator;
       // ignore if we have a different kind of problem
       if (realVectorCreator != null) {
@@ -214,5 +237,5 @@
 
     protected override void OnStarted() {
-      var realVectorCreator = Problem.SolutionCreator as RealVectorCreator;
+      var realVectorCreator = Problem.SolutionCreator as IRealVectorCreator;
       // must catch the case that user loaded an unsupported problem
       if (realVectorCreator == null)
@@ -225,6 +248,18 @@
     }
 
+    private void UpdateAnalyzers() {
+      Analyzer.Operators.Clear();
+      if (Problem != null) {
+        foreach (var a in Problem.Operators.OfType<IAnalyzer>()) {
+          foreach (var param in a.Parameters.OfType<IScopeTreeLookupParameter>())
+            param.Depth = 0;
+          Analyzer.Operators.Add(a, a.EnabledByDefault);
+        }
+      }
+      Analyzer.Operators.Add(analyzer, analyzer.EnabledByDefault);
+    }
+
     private void ParameterizeOperators() {
-      var realVectorCreator = Problem.SolutionCreator as RealVectorCreator;
+      var realVectorCreator = Problem.SolutionCreator as IRealVectorCreator;
       // ignore if we have a different kind of problem
       if (realVectorCreator != null) {
@@ -233,5 +268,4 @@
         makeStep.PointParameter.ActualName = realVectorParameterName;
         analyzer.PointParameter.ActualName = realVectorParameterName;
-        finalAnalyzer.PointParameter.ActualName = realVectorParameterName;
       }
 
@@ -239,5 +273,4 @@
       updateResults.QualityParameter.ActualName = qualityParameterName;
       analyzer.QualityParameter.ActualName = qualityParameterName;
-      finalAnalyzer.QualityParameter.ActualName = qualityParameterName;
     }
   }
Index: branches/HivePerformance/sources/HeuristicLab.Algorithms.GradientDescent/3.3/LbfgsInitializer.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Algorithms.GradientDescent/3.3/LbfgsInitializer.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Algorithms.GradientDescent/3.3/LbfgsInitializer.cs	(revision 9444)
@@ -38,4 +38,5 @@
     private const string IterationsParameterName = "Iterations";
     private const string ApproximateGradientsParameterName = "ApproximateGradients";
+    private const string GradientCheckStepSizeParameterName = "GradientCheckStepSize";
 
     #region Parameter Properties
@@ -53,4 +54,7 @@
     public ILookupParameter<BoolValue> ApproximateGradientsParameter {
       get { return (ILookupParameter<BoolValue>)Parameters[ApproximateGradientsParameterName]; }
+    }
+    public ILookupParameter<DoubleValue> GradientStepSizeParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters[GradientCheckStepSizeParameterName]; }
     }
 
@@ -74,4 +78,5 @@
       Parameters.Add(new LookupParameter<BoolValue>(ApproximateGradientsParameterName,
                                                     "Flag that indicates if gradients should be approximated."));
+      Parameters.Add(new LookupParameter<DoubleValue>(GradientCheckStepSizeParameterName, "Step size for the gradient check (should be used for debugging the gradient calculation only)."));
       // out
       Parameters.Add(new LookupParameter<LbfgsState>(StateParameterName, "The state of the LM-BFGS algorithm."));
@@ -93,5 +98,6 @@
       alglib.minlbfgs.minlbfgssetcond(state, 0.0, 0, 0, Iterations.Value);
       alglib.minlbfgs.minlbfgssetxrep(state, true);
-      // alglib.minlbfgs.minlbfgssetgradientcheck(state, 0.000001);
+      if (GradientStepSizeParameter.ActualValue != null && GradientStepSizeParameter.ActualValue.Value > 0)
+        alglib.minlbfgs.minlbfgssetgradientcheck(state, GradientStepSizeParameter.ActualValue.Value);
 
       PointParameter.ActualValue = new RealVector(initialPoint);
Index: branches/HivePerformance/sources/HeuristicLab.Algorithms.GradientDescent/3.3/LbfgsMakeStep.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Algorithms.GradientDescent/3.3/LbfgsMakeStep.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Algorithms.GradientDescent/3.3/LbfgsMakeStep.cs	(revision 9444)
@@ -79,4 +79,12 @@
         alglib.minlbfgs.minlbfgsreport rep = new alglib.minlbfgs.minlbfgsreport();
         alglib.minlbfgs.minlbfgsresults(state.State, ref x, rep);
+        if (rep.terminationtype < 0) {
+          if (rep.terminationtype == -1)
+            throw new OperatorExecutionException(this, "Incorrect parameters were specified.");
+          else if (rep.terminationtype == -2)
+            throw new OperatorExecutionException(this, "Rounding errors prevent further improvement.");
+          else if (rep.terminationtype == -7)
+            throw new OperatorExecutionException(this, "Gradient verification failed.");
+        }
         PointParameter.ActualValue = new RealVector(x);
       }
Index: branches/HivePerformance/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveJobManagerView.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveJobManagerView.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveJobManagerView.cs	(revision 9444)
@@ -119,5 +119,5 @@
 
     protected override void OnClosing(FormClosingEventArgs e) {
-      if (Content != null && Content.Jobs.Any(x => x.IsProgressing)) {
+      if (Content != null && Content.Jobs != null && Content.Jobs.Any(x => x.IsProgressing)) {
         DialogResult result = MessageBox.Show("There are still unfinished down/uploads. Are you sure you want to close the window?", "HeuristicLab Hive Job Manager", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
 
@@ -131,5 +131,5 @@
 
     protected override void OnClosed(FormClosedEventArgs e) {
-      if (Content != null) {
+      if (Content != null && Content.Jobs != null) {
         Content.ClearHiveClient();
         Content = null;
Index: branches/HivePerformance/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.cs	(revision 9444)
@@ -76,5 +76,4 @@
       Content.ExecutionStateChanged += new EventHandler(Content_ExecutionStateChanged);
       Content.ExecutionTimeChanged += new EventHandler(Content_ExecutionTimeChanged);
-      Content.IsAllowedPrivilegedChanged += new EventHandler(Content_IsAllowedPrivilegedChanged);
       Content.Loaded += new EventHandler(Content_Loaded);
       Content.TaskReceived += new EventHandler(Content_TaskReceived);
@@ -145,5 +144,5 @@
           executionTimeTextBox.Text = Content.ExecutionTime.ToString();
           resourceNamesTextBox.Text = Content.Job.ResourceNames;
-          isPrivilegedCheckBox.Checked = Content.IsAllowedPrivileged;
+          isPrivilegedCheckBox.Checked = Content.Job.IsPrivileged;
           refreshAutomaticallyCheckBox.Checked = Content.RefreshAutomatically;
           logView.Content = Content.Log;
@@ -327,4 +326,5 @@
         runCollectionViewHost.Content = GetAllRunsFromJob(Content);
       }
+      isPrivilegedCheckBox.Checked = Content.Job.IsPrivileged;
     }
 
@@ -368,12 +368,4 @@
       else {
         UpdateStateLogList();
-      }
-    }
-    private void Content_IsAllowedPrivilegedChanged(object sender, EventArgs e) {
-      if (InvokeRequired)
-        Invoke(new EventHandler(Content_IsAllowedPrivilegedChanged), sender, e);
-      else {
-        isPrivilegedCheckBox.Checked = Content.IsAllowedPrivileged;
-        SetEnabledStateOfControls();
       }
     }
@@ -478,5 +470,5 @@
 
     private void isPrivilegedCheckBox_CheckChanged(object sender, EventArgs e) {
-      if (Content != null && !SuppressEvents) Content.IsAllowedPrivileged = isPrivilegedCheckBox.Checked;
+      if (Content != null && !SuppressEvents) Content.Job.IsPrivileged = isPrivilegedCheckBox.Checked;
     }
 
Index: branches/HivePerformance/sources/HeuristicLab.Clients.Hive/3.3/HiveClient.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Clients.Hive/3.3/HiveClient.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Clients.Hive/3.3/HiveClient.cs	(revision 9444)
@@ -113,5 +113,5 @@
 
         foreach (var j in jobsLoaded) {
-          jobs.Add(new RefreshableJob(j) { IsAllowedPrivileged = this.isAllowedPrivileged });
+          jobs.Add(new RefreshableJob(j));
         }
       }
@@ -452,4 +452,5 @@
         IDictionary<Guid, HiveTask> allHiveTasks = downloader.Results;
         var parents = allHiveTasks.Values.Where(x => !x.Task.ParentTaskId.HasValue);
+        refreshableJob.Job.IsPrivileged = allHiveTasks.Any(x => x.Value.Task.IsPrivileged);
 
         refreshableJob.Progress.Status = "Downloading/deserializing complete. Displaying tasks...";
Index: branches/HivePerformance/sources/HeuristicLab.Clients.Hive/3.3/RefreshableJob.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Clients.Hive/3.3/RefreshableJob.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Clients.Hive/3.3/RefreshableJob.cs	(revision 9444)
@@ -110,5 +110,5 @@
             }
           } else {
-            StopResultPolling();
+            PauseResultPolling();
           }
         }
@@ -157,15 +157,4 @@
     }
 
-    // may execute jobs with privileged permissions on slaves
-    public bool IsAllowedPrivileged {
-      get { return Job.IsPrivileged; }
-      set {
-        if (value != Job.IsPrivileged) {
-          Job.IsPrivileged = value;
-          OnIsAllowedPrivilegedChanged();
-        }
-      }
-    }
-
     private Progress progress;
     public Progress Progress {
@@ -196,7 +185,7 @@
       this.HiveTasks = new ItemCollection<HiveTask>();
     }
-    public RefreshableJob(Job hiveExperiment) {
+    public RefreshableJob(Job hiveJob) {
       this.refreshAutomatically = true;
-      this.Job = hiveExperiment;
+      this.Job = hiveJob;
       this.log = new ThreadSafeLog();
       this.jobDownloader = new ConcurrentTaskDownloader<ItemTask>(Settings.Default.MaxParallelDownloads, Settings.Default.MaxParallelDownloads);
@@ -239,6 +228,14 @@
     public void StopResultPolling() {
       if (jobResultPoller != null && jobResultPoller.IsPolling) {
+        refreshAutomatically = false;
         jobResultPoller.Stop();
         DeregisterResultPollingEvents();
+        jobResultPoller = null;
+      }
+    }
+
+    public void PauseResultPolling() {
+      if (jobResultPoller != null && jobResultPoller.IsPolling) {
+        jobResultPoller.Stop();
       }
     }
@@ -425,10 +422,4 @@
     }
 
-    public event EventHandler IsAllowedPrivilegedChanged;
-    private void OnIsAllowedPrivilegedChanged() {
-      var handler = IsAllowedPrivilegedChanged;
-      if (handler != null) handler(this, EventArgs.Empty);
-    }
-
     public event EventHandler JobStatisticsChanged;
     private void OnJobStatisticsChanged() {
@@ -515,10 +506,9 @@
     public event EventHandler HiveTasksChanged;
     protected virtual void OnHiveTasksChanged() {
-      StopResultPolling();
       if (this.HiveTasks != null && this.HiveTasks.Count > 0 && this.GetAllHiveTasks().All(x => x.Task.Id != Guid.Empty)) {
         if (IsFinished()) {
           this.ExecutionState = Core.ExecutionState.Stopped;
           this.RefreshAutomatically = false;
-          if (jobResultPoller != null) DeregisterResultPollingEvents();
+          StopResultPolling();
         } else {
           this.RefreshAutomatically = true;
Index: branches/HivePerformance/sources/HeuristicLab.Core/3.3/OperatorExecutionException.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Core/3.3/OperatorExecutionException.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Core/3.3/OperatorExecutionException.cs	(revision 9444)
@@ -25,8 +25,10 @@
 namespace HeuristicLab.Core {
   public class OperatorExecutionException : Exception {
-    private IOperator op;
+    private readonly IOperator op;
     public IOperator Operator {
       get { return op; }
     }
+
+    private readonly string message;
     public override string Message {
       get {
@@ -38,5 +40,5 @@
         }
         if (InnerException == null)
-          return base.Message + name + ".";
+          return base.Message + name + message + ".";
         else
           return base.Message + name + ": " + InnerException.Message;
@@ -44,8 +46,10 @@
     }
 
-    public OperatorExecutionException(IOperator op)
+    public OperatorExecutionException(IOperator op) : this(op, string.Empty) { }
+    public OperatorExecutionException(IOperator op, string message)
       : base("An exception was thrown by the operator ") {
       if (op == null) throw new ArgumentNullException();
       this.op = op;
+      this.message = message;
     }
     public OperatorExecutionException(IOperator op, Exception innerException)
Index: branches/HivePerformance/sources/HeuristicLab.Data.Views/3.3/EnhancedStringConvertibleMatrixView.Designer.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Data.Views/3.3/EnhancedStringConvertibleMatrixView.Designer.cs	(revision 9444)
+++ branches/HivePerformance/sources/HeuristicLab.Data.Views/3.3/EnhancedStringConvertibleMatrixView.Designer.cs	(revision 9444)
@@ -0,0 +1,93 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Data.Views {
+  partial class EnhancedStringConvertibleMatrixView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.showHideRows = new System.Windows.Forms.ToolStripMenuItem();
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
+      this.SuspendLayout();
+      // 
+      // rowsTextBox
+      // 
+      this.errorProvider.SetIconAlignment(this.rowsTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
+      this.errorProvider.SetIconPadding(this.rowsTextBox, 2);
+      //
+      // dataGridView
+      //
+      this.dataGridView.CellPainting += new System.Windows.Forms.DataGridViewCellPaintingEventHandler(dataGridView_CellPainting);
+      // 
+      // contextMenu
+      // 
+      this.contextMenu.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
+            this.showHideRows});
+      // 
+      // ShowHideRows
+      // 
+      this.showHideRows.Name = "ShowHideRows";
+      this.showHideRows.Size = new System.Drawing.Size(190, 22);
+      this.showHideRows.Text = "Show / Hide Rows";
+      this.showHideRows.Click += new System.EventHandler(this.ShowHideRows_Click);
+      // 
+      // ColoredStringConvertibleMatrixView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Name = "ColoredStringConvertibleMatrixView";
+      this.ShowRowsAndColumnsTextBox = false;
+      this.ShowStatisticalInformation = false;
+      this.Controls.SetChildIndex(this.statisticsTextBox, 0);
+      this.Controls.SetChildIndex(this.rowsLabel, 0);
+      this.Controls.SetChildIndex(this.columnsLabel, 0);
+      this.Controls.SetChildIndex(this.rowsTextBox, 0);
+      this.Controls.SetChildIndex(this.columnsTextBox, 0);
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+    #endregion
+
+    protected System.Windows.Forms.ToolStripMenuItem showHideRows;
+  }
+}
Index: branches/HivePerformance/sources/HeuristicLab.Data.Views/3.3/EnhancedStringConvertibleMatrixView.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Data.Views/3.3/EnhancedStringConvertibleMatrixView.cs	(revision 9444)
+++ branches/HivePerformance/sources/HeuristicLab.Data.Views/3.3/EnhancedStringConvertibleMatrixView.cs	(revision 9444)
@@ -0,0 +1,125 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Drawing;
+using System.Linq;
+using System.Windows.Forms;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Data.Views {
+  public partial class EnhancedStringConvertibleMatrixView : StringConvertibleMatrixView {
+    private bool[] columnVisibility, rowVisibility;
+
+    // sets the visibility of its columns for the next time it is updated
+    public IEnumerable<bool> ColumnVisibility {
+      get { return columnVisibility; }
+      set { columnVisibility = value.ToArray(); }
+    }
+    // sets the visibility of its rows for the next time it is updated
+    public IEnumerable<bool> RowVisibility {
+      get { return rowVisibility; }
+      set { rowVisibility = value.ToArray(); }
+    }
+
+    public double Maximum { get; set; }
+    public double Minimum { get; set; }
+
+    public new DoubleMatrix Content {
+      get { return (DoubleMatrix)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public EnhancedStringConvertibleMatrixView() {
+      InitializeComponent();
+    }
+
+    public void ResetVisibility() {
+      columnVisibility = null;
+      rowVisibility = null;
+    }
+
+    protected override void UpdateColumnHeaders() {
+      base.UpdateColumnHeaders();
+      if (columnVisibility != null && Content != null && columnVisibility.Count() == dataGridView.ColumnCount) {
+        int i = 0;
+        foreach (var visibility in columnVisibility) {
+          dataGridView.Columns[i].Visible = visibility;
+          i++;
+        }
+      }
+    }
+    protected override void UpdateRowHeaders() {
+      if (Content == null) return;
+      if (rowVisibility != null && rowVisibility.Count() != dataGridView.RowCount) return;
+
+      for (int index = 0; index < dataGridView.RowCount; index++) {
+        dataGridView.Rows[index].HeaderCell.Value = Content.RowNames.ElementAt(virtualRowIndices[index]);
+
+        if (rowVisibility != null) {
+          dataGridView.Rows[index].Visible = rowVisibility.ElementAt(virtualRowIndices[index]);
+        } else {
+          dataGridView.Rows[index].Visible = true;
+        }
+      }
+    }
+
+    protected virtual void ShowHideRows_Click(object sender, EventArgs e) {
+      var dialog = new StringConvertibleMatrixRowVisibilityDialog(this.dataGridView.Rows.Cast<DataGridViewRow>());
+      dialog.ShowDialog();
+      RowVisibility = dialog.Visibility;
+    }
+
+    protected override void ShowHideColumns_Click(object sender, EventArgs e) {
+      var dialog = new StringConvertibleMatrixColumnVisibilityDialog(this.dataGridView.Columns.Cast<DataGridViewColumn>());
+      dialog.ShowDialog();
+      ColumnVisibility = dialog.Visibility;
+    }
+
+    protected void dataGridView_CellPainting(object sender, DataGridViewCellPaintingEventArgs e) {
+      if (Content == null) return;
+      if (e.RowIndex < 0) return;
+      if (e.ColumnIndex < 0) return;
+      if (e.State.HasFlag(DataGridViewElementStates.Selected)) return;
+      if (!e.PaintParts.HasFlag(DataGridViewPaintParts.Background)) return;
+
+      int rowIndex = virtualRowIndices[e.RowIndex];
+      Color backColor = GetDataPointColor(Content[rowIndex, e.ColumnIndex], Minimum, Maximum);
+      using (Brush backColorBrush = new SolidBrush(backColor)) {
+        e.Graphics.FillRectangle(backColorBrush, e.CellBounds);
+      }
+      e.PaintContent(e.CellBounds);
+      e.Handled = true;
+    }
+
+    protected virtual Color GetDataPointColor(double value, double min, double max) {
+      if (double.IsNaN(value)) {
+        return Color.DarkGray;
+      }
+      IList<Color> colors = ColorGradient.Colors;
+      int index = (int)((colors.Count - 1) * (value - min) / (max - min));
+      if (index >= colors.Count) index = colors.Count - 1;
+      if (index < 0) index = 0;
+      return colors[index];
+    }
+  }
+}
Index: branches/HivePerformance/sources/HeuristicLab.Data.Views/3.3/HeuristicLab.Data.Views-3.3.csproj
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Data.Views/3.3/HeuristicLab.Data.Views-3.3.csproj	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Data.Views/3.3/HeuristicLab.Data.Views-3.3.csproj	(revision 9444)
@@ -121,4 +121,10 @@
       <DependentUpon>DoubleRangeView.cs</DependentUpon>
     </Compile>
+    <Compile Include="EnhancedStringConvertibleMatrixView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="EnhancedStringConvertibleMatrixView.Designer.cs">
+      <DependentUpon>EnhancedStringConvertibleMatrixView.cs</DependentUpon>
+    </Compile>
     <Compile Include="IntRangeView.cs">
       <SubType>UserControl</SubType>
Index: branches/HivePerformance/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixView.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixView.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixView.cs	(revision 9444)
@@ -453,4 +453,8 @@
     #endregion
 
+    public int GetRowIndex(int originalIndex) {
+      return virtualRowIndices[originalIndex];
+    }
+
     public class RowComparer : IComparer<int> {
       public RowComparer() {
